/*
 * Botendo
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

package net.moonleay.botendo.util

import dev.kord.common.entity.ButtonStyle
import dev.kord.rest.builder.component.ActionRowBuilder

object ButtonUtil {
    fun getMusicControllerButtons(isPaused: Boolean, isRepeating: Boolean): ActionRowBuilder {
        val ar = ActionRowBuilder()
        ar.interactionButton(ButtonStyle.Secondary, "btn.music.repeat") {
            this.label = if (isRepeating) "Stop Repeating" else "Repeat"
        }
        ar.interactionButton(ButtonStyle.Success, "btn.music.pause") {
            this.label = if (isPaused) "Continue" else "Pause"
        }
        ar.interactionButton(ButtonStyle.Primary, "btn.music.skip") {
            this.label = "Skip"
        }
        ar.interactionButton(ButtonStyle.Secondary, "btn.music.queue") {
            this.label = "Queue"
        }
        ar.interactionButton(ButtonStyle.Danger, "btn.music.stop") {
            this.label = "Stop"
        }
        return ar
    }

}
